Name: scc
Summary: Optimizing Scheme compiler
Distribution: Red Hat Contrib|Net
Copyright: Distributable
Group: Development/Languages
Packager: Red Hat Contrib|Net <rhcn-bugs@redhat.com>
Vendor: David Fox <dsfox@cogsci.ucsd.edu>

%define VERSION 1998
%define RELEASE 65
Version: %{VERSION}
Release: %{RELEASE}
Source: ftp://gatekeeper.dec.com/pub/DEC/Scheme-to-C/15mar93.tar.Z
%ifos cygwin32
Patch1: ftp://gatekeeper.dec.com/pub/DEC/Scheme-to-C/LINUX-15mar93.patches.tar.Z
%else
Patch1: ftp://gatekeeper.dec.com/pub/DEC/Scheme-to-C/LINUX-15mar93.patches
%endif
Patch2: ftp://gatekeeper.dec.com/pub/DEC/Scheme-to-C/SOL2-15mar93.patches
Patch3: LINUX-24feb97.patch
Patch31: scc-paths.patch
Patch4: scc-cygwin32.patch
Patch5: scc-extension1.patch
Patch6: scc-nomangle.patch
Patch7:  scc-expander.patch
Patch8:  scc-reader.patch
Patch9:  scc-initfile.patch
Patch10: scc-c-declare.patch
Patch11: scc-inline.patch
Patch12: scc-xshm.patch
Patch13: scc-keyword.patch
Patch14: scc-define-expander.patch
Patch15: scc-debug.patch
Patch16: scc-sizeof.patch
Patch18: scc-doc.patch
Patch19: scc-heapsize.patch
Patch20: scc-nomangle2.patch
Patch21: scc-extension2.patch
Patch22: scc-define-expander2.patch
Patch23: scc-truelist.patch
Patch25: scc-cdecl.patch
Patch26: scc-xlib.patch
Patch17: scc-xptr.patch
Patch27: scc-shared-lib.patch
Patch28: scc-argv.patch
Patch29: scc-eq-before-equal.patch
Patch30: scc-qobi.patch
Patch32: scc-builtin.patch
Patch33: scc-warning.patch
Patch34: scc-linecount.patch
Patch35: scc-transform-bug.patch
Patch36: scc-version.patch
BuildRoot: /tmp/scc

%description

Scheme compiler by Joel Bartlett of DEC Western Research Lab.  The
most recent version from DEC was called "15mar93", I've renamed this
version "1998".  This is the only free Scheme compiler I know of that
works under both Unix and Windows.  It includes a nice foreign
function and structure interface generation package and an interface
to Xlib.  There is also a rewrite of tinyCLOS available along with 
various other library packages.

%changelog

* Fri Nov 20 1998 David Fox <dsf@pipeline.ucsd.edu>

Release 65 -- Y2K compliance, changed version from 98 to 1998.

* Wed Oct 14 1998 root <dsf@pipeline.ucsd.edu>

Release 63 -- Began to add a conversion from scheme boolean to C integer.
Added a check for conflicting typedefs to cdecl.

* Wed Oct 14 1998 root <dsf@pipeline.ucsd.edu>

Release 62 -- Switch to using the suffix "*" rather than "P" to
signify pointers in the xlib interface.

* Tue Oct  6 1998 root <dsf@pipeline.ucsd.edu>

Release 61 -- Fixed nasty cdecl alignment bug.  I think.

* Mon Oct  5 1998 root <dsf@pipeline.ucsd.edu>

Release 60 -- Changed return type of XGetVisualInfo from pointer to an array.

* Thu Sep 10 1998 root <dsf@pipeline.ucsd.edu>

Release 55 -- Fixed a bug in cdecl where we called memcpy instead of memcpy*.

* Wed Aug 19 1998 David Fox <fox@cat.nyu.edu>

Release 51 -- Support for returning pointers to structure elements in the
cdecl code, built-in memcpy function for making copies of structure elements.

* Mon Jul 13 1998 David Fox <fox@cat.nyu.edu>

Release 48 -- Additional fix for treatment of MAXARGS in apply.c

* Thu Jul  9 1998 David Fox <fox@cat.nyu.edu>

Release 47 -- Fixed treatment of MAXARGS in apply.c

* Thu Jul  2 1998 David Fox <fox@cat.nyu.edu>

Release 46 -- added bool support to the cdecl system.

%package debug
Summary: Version of compiler with debugging symbols.
Group: Development/Languages

%description debug
Version of compiler with debugging symbols - for debugging the compiler,
not needed for debugging scheme programs.

%ifos Linux
%define ARCH LINUX
%define PREFIX /usr
%define LIBDIR %{PREFIX}/lib
%define LIBEXT so
%define BINEXT 
%define SCC ../scsc/scc
%endif

%ifos cygwin32
%define ARCH CYGWIN32
%define PREFIX /Cygnus/B19/H-i386-cygwin32
%define LIBDIR %{PREFIX}/lib
%define LIBEXT a
%define BINEXT .exe
%define SCC ../scsc/sccomp
%endif

%ifos SunOS
%define PREFIX /graphics.b/fox
%define ARCH SPARC
%define LIBDIR %{PREFIX}/lib/schemetoc
%define LIBEXT so
%define BINEXT 
%define SCC ../scsc/scc
%endif

%define SCCFLAGS -LIBDIR ../scrt -L../scrt
%define CC gcc

%prep

##
## This spec file builds a heavily modified version of Schemetoc.  Because
## it is a self-compiling system, these modifications occur in three stages:
##
##   1) First, the original compiler is built.
##   2) Then, the source code is modified and the original compiler is
##      used to build the new compiler.
##   3) Finally, some further modifications are made to the source so that
##      it can be compiled by the new compiler, which is then used to
##      recompile itself.
##
## All but the stage 3 is done in the prep section, so that the %patch
## directive is available.
##

##########################################################################
##                                                                      ##
##                                STAGE 1                               ##
##                                                                      ##
##########################################################################

%ifos cygwin32
%setup -T -c -n scc
tar xfz $RPM_SOURCE_DIR/15mar93.tar.Z || true
%else
%setup -c -n scc-%{VERSION}
%endif

##
## First apply the patches that were retrieved from the DEC ftp site
## and patches that are necessary to build the original system.
##

%ifos Linux cygwin32
uudecode $RPM_SOURCE_DIR/LINUX-15mar93.patches
gunzip < LINUX-15mar93.patches.tar.Z | tar xf -
%endif

%ifos Linux cygwin32
patch -p0 -b --suffix=.linux1~ < linux.diff
%patch3 -p1 -b .linux2~
%endif

%ifos SunOS
cat $RPM_SOURCE_DIR/SOL2-15mar93.patches | \
  sed -e '1,64d' -e 's/patch < diffs/patch -p0 -b --suffix=.solaris~ < diffs/' | sh
cat $RPM_SOURCE_DIR/SOL2-15mar93.patches | sed '64q' > README.solaris
%endif

##
## Apply some patches that are needed early, mostly to allow the initial
## compiler to build on architectures other than linux.  The transform
## patch disables an optimization that seems to be defective.
##

%patch31 -p1 -b .paths~
%patch35 -p1 -b .tranform~

##
## Now apply the machine dependent patches.
##

%ifos cygwin32
%patch4 -p1 -b .cygwin32~
%endif

##
## Configure and build the bootstrap system.
##

%ifos Linux
make forLINUX
%endif

%ifos cygwin32
make forCYGWIN32
%endif

%ifos SunOS
cd %{ARCH}
./build
./configure sunos5
%endif

##
## Enter the appropriate build directory for this architecture and
## make the bootstrap system from the pre-compiled .c files.
##

cd %{ARCH}

# Re-create scc with the build path.
rm -f scsc/scc
DIR=$RPM_BUILD_DIR/$RPM_PACKAGE_NAME-$RPM_PACKAGE_VERSION/%{ARCH}
cd scsc; make BINDIR=$DIR/scsc LIBDIR=$DIR/scrt scc; cd ..

make CC=%{CC} E=%{LIBEXT} X=%{BINEXT} BINDIR=%{PREFIX}/bin LIBDIR=%{PREFIX}/lib port

##########################################################################
##                                                                      ##
##                                STAGE 2                               ##
##                                                                      ##
##########################################################################

##
## Apply the patches which implement new functionality and will later
## require changes to the compiler source for the resulting compiler
## to compile itself.
##

cd ..

# This patch changes the standard Scheme extension from .sc to .scm.
# However, the bootstrap compiler won't recognize such files, so we
# don't rename the source files or patch the makefiles until later.

patch -p1 -b --suffix=.extension1~ < $RPM_SOURCE_DIR/scc-extension1.patch

# This patch removes the long symbol mangling from the compiler.  In
# this case, the code produced by the resulting compiler won't be
# compatible with that produced heretofore, so all the .c files must
# be removed.

patch -p1 -b --suffix=.nomangle~ < $RPM_SOURCE_DIR/scc-nomangle.patch

# This patch renames the original define-macro directive to
# define-expander, and adds a more conventional definition for
# define-macro.  This requires changes to the source code down below.

patch -p1 -b --suffix=.expander1~ < $RPM_SOURCE_DIR/scc-define-expander.patch

# The c-declare directive is needed to compile the new sizeof.scm file.

patch -p1 -b --suffix=.c-declare~ < $RPM_SOURCE_DIR/scc-c-declare.patch

##
## Now rebuild the compiler from the patched sources
##

cd %{ARCH}
make clean clean-sc-to-c
make SCC=../scsc/sccomp SCCFLAGS="-LIBDIR ../scrt -L../scrt" CC=%{CC} E=a X=%{BINEXT} all

##########################################################################
##                                                                      ##
##                                STAGE 3                               ##
##                                                                      ##
##########################################################################

##
## Now we have the modified compiler, so we need to modify its source
## so that it can compile itself.  This modification includes changing
## the file extensions from ".sc" to ".scm".
## 

cd ..
patch -p1 -b --suffix=.nomangle2~ < $RPM_SOURCE_DIR/scc-nomangle2.patch
patch -p1 -b --suffix=.extension2~ < $RPM_SOURCE_DIR/scc-extension2.patch
patch -p1 -b --suffix=.expander2~ < $RPM_SOURCE_DIR/scc-define-expander2.patch

cd %{ARCH}
for i in `find . -name '*.sc' -print`; do
  rm -f $i `dirname $i`/`basename $i .sc`.[co]
  ln -s ../../${i}m ${i}m
done
cd ..

for i in `find . -name '*.sc' -print`; do
  mv $i ${i}m
done

##
## Changes from here down are self-contained, they are not part of the
## three stage compilation procedure.  (Most of the patches in stage
## two probably belong here.)
##

## These two are bug fixes
patch -p1 -b --suffix=.expanderbug~ < $RPM_SOURCE_DIR/scc-expander.patch
patch -p1 -b --suffix=.readerbug~ < $RPM_SOURCE_DIR/scc-reader.patch

## Include an initialization file (scc.sch) at compiler startup
patch -p1 -b --suffix=.initfile~ < $RPM_SOURCE_DIR/scc-initfile.patch

## Obsolete
patch -p1 -b --suffix=.xshm~ < $RPM_SOURCE_DIR/scc-xshm.patch

## Identifiers starting with ":" are always bound to themselves
patch -p1 -b --suffix=.keyword~ < $RPM_SOURCE_DIR/scc-keyword.patch

## Build a debugging library, support the -g flag when linking
patch -p1 -b --suffix=.debug~ < $RPM_SOURCE_DIR/scc-debug.patch

## Add built in functions to return information about basic C types
patch -p1 -b --suffix=.sizeof~ < $RPM_SOURCE_DIR/scc-sizeof.patch

## Create a latex version of the documentation
patch -p1 -b --suffix=.doc~ < $RPM_SOURCE_DIR/scc-doc.patch

## Change default initial heap from 2 meg to 20, default max from 15 to 40.
patch -p1 -b --suffix=.heapsize~ < $RPM_SOURCE_DIR/scc-heapsize.patch

## Make the empty list a true value
patch -p1 -b --suffix=.truelist~ < $RPM_SOURCE_DIR/scc-truelist.patch

## Create the cdecl.sch header file, integrate sizeof program into compiler.
patch -p1 -b --suffix=.cdecl~ < $RPM_SOURCE_DIR/scc-cdecl.patch

## Create the header file version of the Xlib interface
patch -p1 -b --suffix=.xlib~ < $RPM_SOURCE_DIR/scc-xlib.patch

## Change from using "P" to signify pointers to using "*"
patch -p1 -b --suffix=.xptr~ < $RPM_SOURCE_DIR/scc-xptr.patch

## Build a shared dynamic run-time library
patch -p1 -b --suffix=.shared-lib~ < $RPM_SOURCE_DIR/scc-shared-lib.patch

## Allow argv[0] to be #f - its not available under Win32
patch -p1 -b --suffix=.argv~ < $RPM_SOURCE_DIR/scc-argv.patch

## In the "equal?" function, perform the eq? test before the normal tests.
## This prevents a possible endless loop when comparing circular structures.
patch -p1 -b --suffix=.eq-equal~ < $RPM_SOURCE_DIR/scc-eq-before-equal.patch

## Qobi infrastructure-0.7 patches.
patch -p1 -b --suffix=.qobi~ < $RPM_SOURCE_DIR/scc-qobi.patch

## Patch to allow calling of built-in C functions
patch -p1 -b --suffix=.builtin~ < $RPM_SOURCE_DIR/scc-builtin.patch

## Patch to fix a warning message that was going to standard output
patch -p1 -b --suffix=.warning~ < $RPM_SOURCE_DIR/scc-warning.patch

## Patch to add line numbers to the compiler error messages.
patch -p1 -b --suffix=.linecount~ < $RPM_SOURCE_DIR/scc-linecount.patch

## Patch to change the version number with each release
patch -p1 -b --suffix=.version~ < $RPM_SOURCE_DIR/scc-version.patch

##
## Add some new links for new source files, remove some obsolete ones.
##

rm -f cdecl/*.scm cdecl/sizeof.c cdecl/makefile
rm -f xlib/*.cdecl %{ARCH}/xlib/*.cdecl xlib/xlib.scm %{ARCH}/xlib/xlib.scm
ln -s ../../scrt/sizeof.scm %{ARCH}/scrt/sizeof.scm
for i in xlib/*.sc[hm]; do ln -sf ../../$i %{ARCH}/$i; done

%build

cat ports/%{ARCH}/makefile-head scsc/makefile > %{ARCH}/scsc/makefile
cat ports/%{ARCH}/makefile-head scrt/makefile > %{ARCH}/scrt/makefile
cat ports/%{ARCH}/makefile-head scrt/makefile > %{ARCH}/server/makefile
cat ports/%{ARCH}/makefile-head test/makefile > %{ARCH}/test/makefile
cat ports/%{ARCH}/makefile-head xlib/makefile > %{ARCH}/xlib/makefile

##
## Now we'll use the compiler to rebuild itself.
##

cd %{ARCH}
export LD_LIBRARY_PATH=../scrt
make clean clean-sc-to-c

# Sorry for the baroque escape characters here on the release string.
make SCC="%{SCC}" SCCFLAGS="%{SCCFLAGS}" CC="%{CC}" CFLAGS="-DIMPLEMENTATION_VERSION='\\\"%{VERSION}-%{RELEASE}dsf\\\"'" E=%{LIBEXT} X=%{BINEXT} all

## Using this command instead of the one just above builds an
## optimized version of the library and compiler, but the problem with
## this is that the interpreter always seg faults on error rather than
## printing a traceback.  It might be worthwhile to build a compiler
## using this library, but its not a big deal.

#make SCC="%{SCC}" SCCFLAGS="%{SCCFLAGS}" CC=%{CC} SCCFLAGS="-Og -Ob -Ot" CFLAGS="-O2 -DNOLOOPSTACKTRACE" all

##########################################################################
##                                                                      ##
##                                EPILOGUE                              ##
##                                                                      ##
##########################################################################

# Now make the various libraries and tools.

cd scrt
%ifnos SunOS
#make libsc_p.so CC=%{CC} X=%{BINEXT} E=so CFLAGS="-O2 -DNOLOOPSTACKTRACE"
make libsc_p.a CC=%{CC} X=%{BINEXT} E=a CFLAGS="-O2"
%endif
make clean-sc-to-c
make libsc_g.a SCC="%{SCC}" SCCFLAGS="%{SCCFLAGS}" CC=%{CC} X=%{BINEXT} E=a
# We've rebuilt the compiler since libsc.a was created, so create it again.
rm libsc.a
make clean-sc-to-c
make SCC="%{SCC}" SCCFLAGS="%{SCCFLAGS}" CC=%{CC} X=%{BINEXT} E=a Xlibsc.a Xmv

# Build a debugging version of the compiler.  To run it from the
# debugger it needs to be able to start without the shell script
# wrapper, so we fix up the hard coded path here.

cd ../scsc
sed 's:../scrt:%{PREFIX}/lib/schemetoc:' < main.scm > main.scm.tmp
mv -f main.scm.tmp main.scm
rm -f main.c
make SCC="%{SCC}" SCCFLAGS="%{SCCFLAGS}" X=%{BINEXT} main.c
make clean
# We might want to save the source code here too, for the debugger.
make Xsccomp%{BINEXT} SCC="%{SCC}" SCCFLAGS="%{SCCFLAGS}" CC=%{CC} E=a X=%{BINEXT} CFLAGS=-g RT="sc_g"
mv Xsccomp%{BINEXT} sccd%{BINEXT}

%ifnos cygwin32
cd ../xlib
#make X=%{BINEXT} E=a SCC="%{SCC}" SCCFLAGS="%{SCCFLAGS} -I ../../cdecl" SFLAGS="-I ../../cdecl" all
make X=%{BINEXT} E=a SCC="%{SCC}" 
make X=%{BINEXT} E=a SCC="%{SCC}" DEBUG=y
%endif

cd ../test
make X=%{BINEXT} SCC="%{SCC}" SCCFLAGS="%{SCCFLAGS}" test test50 test51 test52 test53 test54
./test
./test50
./test51
./test52
./test54

%install

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{PREFIX}/lib
mkdir -p $RPM_BUILD_ROOT%{PREFIX}/bin

cd %{ARCH}
rm -f scsc/scc
cd scsc; make BINDIR=%{PREFIX}/bin LIBDIR=%{PREFIX}/lib/schemetoc scc; cd ..

cd scrt
%ifos SunOS
make CC=%{CC} E=%{LIBEXT} X=%{BINEXT} BINDIR=${RPM_BUILD_ROOT}%{PREFIX}/bin LIBDIR=${RPM_BUILD_ROOT}%{PREFIX}/lib install
%else
make CC=%{CC} E=%{LIBEXT} X=%{BINEXT} BINDIR=${RPM_BUILD_ROOT}%{PREFIX}/bin LIBDIR=${RPM_BUILD_ROOT}%{LIBDIR} install
%endif
cp libsc.a ${RPM_BUILD_ROOT}%{LIBDIR}
ranlib ${RPM_BUILD_ROOT}%{LIBDIR}/libsc.a
cd ../scsc
make CC=%{CC} E=%{LIBEXT} X=%{BINEXT} BINDIR=${RPM_BUILD_ROOT}%{PREFIX}/bin LIBDIR=${RPM_BUILD_ROOT}%{LIBDIR} install
strip ${RPM_BUILD_ROOT}%{PREFIX}/bin/sci%{BINEXT}
strip ${RPM_BUILD_ROOT}%{PREFIX}/bin/sccomp%{BINEXT}

cp sccd%{BINEXT} ${RPM_BUILD_ROOT}%{PREFIX}/bin/sccd%{BINEXT}

%ifnos cygwin32
cd ../xlib
cp libscx.a ${RPM_BUILD_ROOT}%{PREFIX}/lib
cp libscx_g.a ${RPM_BUILD_ROOT}%{PREFIX}/lib
cp scixl%{BINEXT} ${RPM_BUILD_ROOT}%{PREFIX}/bin/scixl%{BINEXT}
strip ${RPM_BUILD_ROOT}%{PREFIX}/bin/scixl%{BINEXT}
ranlib ${RPM_BUILD_ROOT}%{PREFIX}/lib/libscx.a
ranlib ${RPM_BUILD_ROOT}%{PREFIX}/lib/libscx_g.a
%endif

cd ../..
mkdir -p doc/xlib
cp -f xlib/doc.mss doc/xlib/doc.mss
for i in clear hello hello2 npuzzle puzzle; do
  cp -f xlib/$i.scm doc/xlib/$i.scm; done

mkdir -p ${RPM_BUILD_ROOT}%{PREFIX}/man/man1
cd doc
rm -f *~
cp -f scc.l ${RPM_BUILD_ROOT}%{PREFIX}/man/man1/scc.1
cp -f sci.l ${RPM_BUILD_ROOT}%{PREFIX}/man/man1/sci.1

cd ../cdecl
cp -f cdecl.sch ${RPM_BUILD_ROOT}%{PREFIX}/lib/schemetoc

%ifnos cygwin32
cd ../xlib
cp -f *.sch ${RPM_BUILD_ROOT}%{PREFIX}/lib/schemetoc
%endif

# Create a little filter to demangle scheme identifiers.

cat > ${RPM_BUILD_ROOT}%{PREFIX}/bin/scdemangle << delim
#!/bin/sh

sed -e 's/_2d/-/g' -e 's/_2e/./g' -e 's:_2f:/:g' -e 's/_3e/>/g' \
    -e 's/_3c/</g' -e 's/_3a/:/g' -e 's/_3f/?/g' -e 's/_25/%/g' \
    -e 's/_21/!/g' -e 's/_2a/*/g' -e 's/_3d/=/g'
delim
chmod ugo+x ${RPM_BUILD_ROOT}%{PREFIX}/bin/scdemangle

%post
%ifos Linux
/sbin/ldconfig
%endif

%postun
%ifos Linux
/sbin/ldconfig
%endif

%clean

rm -rf $RPM_BUILD_ROOT

%files

%ifos SunOS
%doc README.solaris
%endif

%doc CHANGES README doc gnuemacs
%doc %{PREFIX}/man/man1/scc.1
%doc %{PREFIX}/man/man1/sci.1
%doc %{ARCH}/xlib/hello %{ARCH}/xlib/hello2
%doc %{ARCH}/xlib/puzzle %{ARCH}/xlib/npuzzle

%{PREFIX}/lib/schemetoc
%ifos Linux SunOS
%{PREFIX}/lib/libsc.%{LIBEXT}
%endif
%{PREFIX}/lib/libsc.a
%ifnos cygwin32
%{PREFIX}/lib/libscx.a
%endif

%{PREFIX}/bin/sci%{BINEXT}
%{PREFIX}/bin/scc
%{PREFIX}/bin/scixl%{BINEXT}
%{PREFIX}/bin/sccomp%{BINEXT}

%files debug
%{PREFIX}/bin/sccd%{BINEXT}
%{PREFIX}/lib/libsc_g.a
%{PREFIX}/lib/libsc_p.a
%{PREFIX}/lib/libscx_g.a
%{PREFIX}/bin/scdemangle
